#include "Binary_tree.h"

int main() {
	Binary_tree<char> a('a');
	AVL_tree<char> b('b'), c('c'), d('d'), e('e');

	a.push_left(&b);
	a.push_right(&c);
	b.push_left(&d);

	assert(a.root() == &a);
	assert(b.root() == &a);
	assert(c.root() == &a);
	assert(d.root() == &a);

	assert(a.isAVL());

	d.push_left(&e);

	assert(e.root() == &a);

	assert(!(&a)->isAVL());

	AVL_tree<char> aa('a');
	AVL_tree<char> bb('b'), cc('c'), dd('d'), ee('e');

	aa.push_left(&bb);
	aa.push_right(&cc);
	bb.push_left(&dd);

	assert(aa.root() == &aa);
	assert(bb.root() == &aa);
	assert(cc.root() == &aa);
	assert(dd.root() == &aa);

	assert(aa.isAVL()); // caution: 'return true;'

	dd.push_left(&ee);

	assert(!(ee.root() == &aa));

	return 0;
}
